#ifndef _EYD_BITUNCOMPRESSOR_RLE2_HH
#define _EYD_BITUNCOMPRESSOR_RLE2_HH

#include <string>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <exception>

#include "eyd_bitgroup.hh"

#include "eyd_global.hh"
#include "eyd_iface.hh"


namespace EydLib {
	typedef enum {
		UNCOMPRESSOR_RLE2_STATUS_NORMAL, 
		UNCOMPRESSOR_RLE2_STATUS_GOTLEN, 
		UNCOMPRESSOR_RLE2_STATUS_GOTRLE} 
	uncompressorRle2_status_t;

	class BitUncompressorRle2 {
		private:
			BitGroup _rle;
			int _last_count;
			int _group_size;
			std::list<BitGroup> _uncompressed;
			uncompressorRle2_status_t _status;

		public:
			BitUncompressorRle2::BitUncompressorRle2();

			void clear();
			void append(BitGroup bg);
			std::list<BitGroup> flush();
			bool hasContent();

			void flushRleData();
			void flushRawData();

	};
}

#endif
